# coding: utf-8
import re

from django.conf import settings

from jmb.core.middleware import thread_local
from acomea.ldap import ldap_models 


class SingleSignOn:

    def process_response(self, request, response):
        """Write cookies to implement single sign on with reply
        """
        
        if settings.LDAP_SERVER and hasattr(request, 'user'):
            if re.match("%s|%s" % (settings.MEDIA_URL, settings.STATIC_URL), request.path):
                return response
            # Al logout request.user è già anonimous, quindi prendo da thread_local
            user = thread_local.get_current_user()

            ldap_user = ldap_models.get_user_by_uid(user.username)
            kw = {'domain': '.acomea.it'}
            if ldap_user:
                response.set_cookie('uid', user.username, **kw)
                response.set_cookie('OTP', ldap_user.otp, **kw)
                response.set_cookie('activityFlag', ldap_user.activity_flag, **kw)
                ldap_user.refresh_otp_expiry()
                ldap_user.save()
            
        return response

